/*
Name: Trace_Lecture8.java
Role: Examples of code to trace from lecture 8

Author: Sam Vinitsky
Date: 6/27
*/

public class Trace_Lecture8 {

    public static void main(String[] args){

        ///////////////////
        // BOOLEAN LOGIC //
        ///////////////////

        // 1) what will the following output?
        // ... how does changing a and b change the output?
        // boolean a = true;
        // boolean b = true;
        // if (a && b){
        //     System.out.println("Yay!");
        // }

        // 2) is there any value of b that would get "Yay!" to print? Why?
        // boolean b = true;
        // if ((6 < 4) && b){
        //     System.out.println("Yay!");
        // }

        // 3) what will the following output?
        // ... how does changing a and b change the output?
        // boolean a = true;
        // boolean b = true;
        // if (a || b){
        //     System.out.println("Boo!");
        // }

        // 4) Is there any value of b that will get "Boo!" to NOT print? Why?
        // boolean b = true;
        // if ((5 < 1000) || b){
        //     System.out.println("Boo!");
        // }

        // 5) what will the following output?
        // if(!(0.5 + 0.2 < 1)){
        //     System.out.println("It was true");
        // } else {
        //     System.out.println("Sad");
        // }


        // 6a) build a truth table for the following expression
        // (s || !t) || (t && !s)
        //
        // 6b) Trace the following code
        // boolean s = false;
        // boolean t = true;
        // if ((s || !t) || (t && !s)){ 
        //     System.out.println("It was true!")
        // } else{
        //     System.out.println("It was false!")
        // }

        // 7) what will the following print?
        // .. change the values and see how the output changes
        // int x = 100;
        // int yy = 22;
        // boolean z = false;
        //
        // if (z || yy<2){
        //     System.out.println("It was true!");
        // } else{
        //     System.out.println("It was false");
        // }
        // if ((x + yy > yy - x) && !z){
        //     System.out.println("The hills are alive!");
        // }

        //////////////////////////
        // Chained conditionals //
        //////////////////////////
        
        // 7) what will the following code print out?
        // double x = 99.99;
        // int y = 100;
        // if (y > 0 || x < 0){
        //     System.out.println("first");
        // } else if (x < y){
        //     System.out.println("first");
        // } else {
        //     System.out.println("third");
        // }

        // 8) What will the following print?
        // ... what if we change b to true?
        // ... what if we change b to true and x to 11?
        // boolean b = false;
        // int x = 7;
        // if (x < 6 && !b){
        //     System.out.println("first");
        // } else if (b && x == 2){
        //     System.out.println("second");
        // } else if (b == (x<4)){
        //     System.out.println("third");
        // }

        /////////////////////////
        // NESTED CONDITIONALS //
        /////////////////////////

        // 9) what will the following print out?
        // int z = 11;
        // int y = 2;
        // if (2 * z < 11 + y){
        //     if (y < 20 || z == y){
        //         System.out.println("first");
        //     } else if (y == z*z){
        //         System.out.println("second");
        //     }
        // } else if ((z < y*y*y*y) == (z > y+y+y+y)){
        //     System.out.println("third");
        //     if (z < 11 || y > 2 && y > 2){
        //         System.out.println("fourth");
        //     } if (true){
        //         System.out.println("fifth");
        //     }
        // }

    }

} 